chicken-bitcoin
===============
An interface to [bitcoind][]'s JSON-RPC API for CHICKEN Scheme.

**This library is obsolete, unsupported, and may not even work.**

If you feel like adopting it, be my guest.

Requirements
------------
Besides [CHICKEN][], the following extensions are required:

* [uri-common][]
* [http-client][]
* [medea][]

Usage
-----
The primary interface is the `bitcoind-request` procedure, which takes a
`bitcoind-connection` object, request type symbol, and parameters
according to the [bitcoind API reference][api]. Request and response
data is translated to and from JSON according to the [medea][]
extension's conversion rules.

When an error response is received from bitcoind, an exception of type `(exn
bitcoin)` is raised.

    > (use bitcoin)
    > (define c (make-bitcoind-connection "http://user:pass@localhost:8332"))
    > (bitcoind-request c 'getblockcount)
    215673
    > (bitcoind-request c 'getblockhash 123456)
    "0000000000002917ed80650c6174aac8dfc46f5fe36480aaef682ff6cd83c3ca"
    > (bitcoind-request c 'getinfo)
    ((version . 110200)
     (protocolversion . 70002)
     (walletversion . 60000)
     (balance . 0.0)
     (blocks . 215673)
     (timeoffset . 0)
     (connections . 0)
     (proxy . "")
     (difficulty . 2979636.61693807)
     (testnet . #f)
     (keypoololdest . 1357260660)
     (keypoolsize . 101)
     (paytxfee . 0.0)
     (relayfee . 5e-05)
     (errors . ""))

Author
------
Evan Hanson <evhan@foldling.org>

License
-------
Public Domain

[bitcoind]: https://en.bitcoin.it/wiki/Bitcoind
[chicken]: http://call-cc.org/
[uri-common]: http://wiki.call-cc.org/egg/uri-common
[http-client]: http://wiki.call-cc.org/egg/http-client
[medea]: http://wiki.call-cc.org/egg/medea
[api]: https://en.bitcoin.it/wiki/Original_Bitcoin_client/API_Calls_list
